import unittest

from pyson.ObjectMapper import ObjectMapper

from geniusweb.actions.PartyId import PartyId
from geniusweb.inform.Agreements import Agreements
from geniusweb.inform.Inform import Inform
from geniusweb.issuevalue.Bid import Bid


class AgreementsTest(unittest.TestCase):
    id1 = PartyId("party1")
    id2 = PartyId("party2")
    bid1 = {}

    agrees1  = Agreements({id1: bid1 })
    agrees2 = Agreements({ id2: bid1 })
    
    agrees1json={'agreements': {'party1': {}}}
    
    def testNull(self) :
        Agreements();

    def testNone(self) :
        self.assertRaises(ValueError, lambda:Agreements(None))

    def testWithAlreadyActed(self) :
        self.assertRaises(ValueError, lambda:self.agrees1.With(self.agrees1))

    def testWith(self):
        agrees = self.agrees1.With(self.agrees2);
        self.assertEquals(self.bid1, agrees.getMap()[self.id1]);
        self.assertEquals(self.bid1, agrees.getMap()[self.id2]);

    def testSerialize(self):
        
        actor=PartyId("myid")
        # HACK currently bid requires all values same type
        
        pyson=ObjectMapper()
        print(str(pyson.toJson(self.agrees1)))
        self.assertEqual(self.agrees1json, pyson.toJson(self.agrees1))
        
    def testDeserialize(self):
        pyson=ObjectMapper()

        self.assertEqual(self.agrees1, pyson.parse(self.agrees1json, Agreements))
        